=== debian/changelog ===
ectrans (1.4.0-1) unstable; urgency=medium

  * New upstream release
    - update patches for new librararies
  * Add loongarch64 support. Closes: #1059601
  * Module directory name changed trans -> ectrans

 -- Alastair McKinstry <mckinstry@debian.org>  Thu, 01 Aug 2024 11:06:45 +0100
