## ectrans 1.5.0

=== debian/changelog ===
ectrans (1.5.0-1) unstable; urgency=medium

  * New upastream release
  * Fix typo in homepage in d/control
  * Drop hard-coded dep on libopenmpi-dev

 -- Alastair McKinstry <mckinstry@debian.org>  Sat, 12 Oct 2024 06:37:33 +0100
