=== debian/control ===
--- 
+++ 
@@ -14,11 +14,10 @@
   liblapack-dev [ !amd64 !arm64 !mips64el !ppc64el !s390x !ppc64],
   mpi-default-dev,
   libfftw3-dev,
-  libopenmpi-dev,
   libfiat-dev,
   fiat-utils
 Standards-Version: 4.7.0
-Homepage: https://github.com/ecmwf-ifs/trans
+Homepage: https://github.com/ecmwf-ifs/ectrans
 Vcs-Browser: https://salsa.debian.org/science-team/ectrans.git
 Vcs-Git: https://salsa.debian.org/science-team/ectrans.git -b debian/latest
