## ectrans 1.5.1

=== debian/changelog ===
ectrans (1.5.1-1) unstable; urgency=medium

  * New upstream release
  * Drop unused config vars ENABLE_DOCS, ENABLE_FORTRAN, ENABLE_FFTW
  * Drop ia64 references in d/control; no  longer suppported
  * Drop B-D on dh-buildinfo

 -- Alastair McKinstry <mckinstry@debian.org>  Fri, 20 Dec 2024 16:04:30 +0000

ectrans (1.5.0-3) unstable; urgency=medium

  * Set archs for HIP to re-enable other archs

 -- Alastair McKinstry <mckinstry@debian.org>  Mon, 18 Nov 2024 17:14:13 +0000

ectrans (1.5.0-2) unstable; urgency=medium

  * Build against openmpi >= 5.0.5-6. Closes: #1086263
  * Experimental HIP support:
    - build-dep on hipcc, librocsolver-dev, libhipblas-dev, libhipfft-dev
      librocfft-dev,
    - set DH_VERBOSE=1
    - set ENABLE_ACC
    - Set CMAKE_HIP_ARCHITECTURES to match math lib supported archs
  * gfortran-fixes.patch: fixes needed for compilation

 -- Alastair McKinstry <mckinstry@debian.org>  Sun, 17 Nov 2024 06:08:38 +0000
